// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{ffi, ContentRatingValue};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "AsContentRating")]
    pub struct ContentRating(Object<ffi::AsContentRating, ffi::AsContentRatingClass>);

    match fn {
        type_ => || ffi::as_content_rating_get_type(),
    }
}

impl ContentRating {
    pub const NONE: Option<&'static ContentRating> = None;

    #[doc(alias = "as_content_rating_new")]
    pub fn new() -> ContentRating {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::as_content_rating_new()) }
    }

    #[doc(alias = "as_content_rating_attribute_from_csm_age")]
    pub fn attribute_from_csm_age(id: &str, age: u32) -> ContentRatingValue {
        assert_initialized_main_thread!();
        unsafe {
            from_glib(ffi::as_content_rating_attribute_from_csm_age(
                id.to_glib_none().0,
                age,
            ))
        }
    }

    #[doc(alias = "as_content_rating_attribute_get_description")]
    pub fn attribute_get_description(id: &str, value: ContentRatingValue) -> Option<glib::GString> {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_none(ffi::as_content_rating_attribute_get_description(
                id.to_glib_none().0,
                value.into_glib(),
            ))
        }
    }

    #[doc(alias = "as_content_rating_attribute_to_csm_age")]
    pub fn attribute_to_csm_age(id: &str, value: ContentRatingValue) -> u32 {
        assert_initialized_main_thread!();
        unsafe {
            ffi::as_content_rating_attribute_to_csm_age(id.to_glib_none().0, value.into_glib())
        }
    }

    #[doc(alias = "as_content_rating_get_all_rating_ids")]
    #[doc(alias = "get_all_rating_ids")]
    pub fn all_rating_ids() -> Vec<glib::GString> {
        assert_initialized_main_thread!();
        unsafe {
            FromGlibPtrContainer::from_glib_container(ffi::as_content_rating_get_all_rating_ids())
        }
    }
}

impl Default for ContentRating {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::ContentRating>> Sealed for T {}
}

pub trait ContentRatingExt: IsA<ContentRating> + sealed::Sealed + 'static {
    #[doc(alias = "as_content_rating_add_attribute")]
    fn add_attribute(&self, id: &str, value: ContentRatingValue) {
        unsafe {
            ffi::as_content_rating_add_attribute(
                self.as_ref().to_glib_none().0,
                id.to_glib_none().0,
                value.into_glib(),
            );
        }
    }

    #[doc(alias = "as_content_rating_get_kind")]
    #[doc(alias = "get_kind")]
    fn kind(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::as_content_rating_get_kind(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_content_rating_get_minimum_age")]
    #[doc(alias = "get_minimum_age")]
    fn minimum_age(&self) -> u32 {
        unsafe { ffi::as_content_rating_get_minimum_age(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "as_content_rating_get_rating_ids")]
    #[doc(alias = "get_rating_ids")]
    fn rating_ids(&self) -> Vec<glib::GString> {
        unsafe {
            FromGlibPtrContainer::from_glib_container(ffi::as_content_rating_get_rating_ids(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_content_rating_get_value")]
    #[doc(alias = "get_value")]
    fn value(&self, id: &str) -> ContentRatingValue {
        unsafe {
            from_glib(ffi::as_content_rating_get_value(
                self.as_ref().to_glib_none().0,
                id.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_content_rating_set_kind")]
    fn set_kind(&self, kind: &str) {
        unsafe {
            ffi::as_content_rating_set_kind(self.as_ref().to_glib_none().0, kind.to_glib_none().0);
        }
    }

    #[doc(alias = "as_content_rating_set_value")]
    fn set_value(&self, id: &str, value: ContentRatingValue) {
        unsafe {
            ffi::as_content_rating_set_value(
                self.as_ref().to_glib_none().0,
                id.to_glib_none().0,
                value.into_glib(),
            );
        }
    }
}

impl<O: IsA<ContentRating>> ContentRatingExt for O {}
